Index: .hgsigs
===================================================================
--- .hgsigs	(revision 3084)
+++ .hgsigs	(revision 3084)
@@ -0,0 +1,1 @@
+266ba234e2a5115e47379030e9439b6abcb11e80 0 iQEcBAABCgAGBQJV1WIcAAoJELwJObfmz3HnHHEH/1+ohmFEzHx5M90oAtQN4pQLsPCZ/fCVG5w6OoD56DOPP3IMaTSxlEzoG3mjWv0gzAb4zJjPErBwRy7keq3rjT5SyDs17aHRmCE91+YuGNBDnQHAD68gVZaQQ+L2d5+EHYdGtxcwiFUyRWEv+U/4NW0UexuJDVqzS6ztUC45D1a2Qt9Q4bbEsywmE5Bl7IP7hjxKlICJNo3fclpCgdryPeB7gatOJz4uw/T6tbJVzvD2ETA/9kp+hg2yFNWBhS0zgK/BKcinqlh2AW4fPDsrOvr7LnIQUt5KwdJmbNA3A8moF2EU9/PiF76tWF5IHtnk9x/bQjCgukZSZ383eUzlY58=
Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 3063)
+++ .hgsubstate	(revision 3092)
@@ -1,1 +1,1 @@
-8be811511655a8c3aabd56fe1cb627811dc43600 inc/libs/clearbricks
+e1a813e9448a149be92b8cbfa824800c7150cfaa inc/libs/clearbricks
Index: .hgtags
===================================================================
--- .hgtags	(revision 3096)
+++ .hgtags	(revision 3098)
@@ -25,3 +25,4 @@
 c45489df2bde825c7ed9c756e00444b54caf8e10 2.7.3
 27e258e592e45b56a803038279adb6faa5865265 2.7.4
+5e377b0f479e0f45cf199b24c3f997449a6f5a8a 2.8.0
 7b52a5c13c7e8129f9a07f38482fe58b25e96349 2.8.1
Index: admin/blog_pref.php
===================================================================
--- admin/blog_pref.php	(revision 3030)
+++ admin/blog_pref.php	(revision 3091)
@@ -587,11 +587,11 @@
 	'<div class="col">'.
 	'<h5>'.__('Generated image sizes (in pixels)').'</h5>'.
-	'<p class="field"><label for="media_img_t_size">Thumbnail</label> '.
+	'<p class="field"><label for="media_img_t_size">'.__('Thumbnail').'</label> '.
 	form::field('media_img_t_size',3,3,$blog_settings->system->media_img_t_size).'</p>'.
 
-	'<p class="field"><label for="media_img_s_size">Small</label> '.
+	'<p class="field"><label for="media_img_s_size">'.__('Small').'</label> '.
 	form::field('media_img_s_size',3,3,$blog_settings->system->media_img_s_size).'</p>'.
 
-	'<p class="field"><label for="media_img_m_size">Medium</label> '.
+	'<p class="field"><label for="media_img_m_size">'.__('Medium').'</label> '.
 	form::field('media_img_m_size',3,3,$blog_settings->system->media_img_m_size).'</p>'.
 	'</div>'.
Index: admin/comments.php
===================================================================
--- admin/comments.php	(revision 3053)
+++ admin/comments.php	(revision 3091)
@@ -245,5 +245,5 @@
 	'<p><label for="order" class="ib">'.__('Sort:').'</label> '.
 	form::combo('order',$order_combo,$order).'</p>'.
-	'<p><span class="label ib">Afficher</span> <label for="nb" class="classic">'.
+	'<p><span class="label ib">'.__('Show').'</span> <label for="nb" class="classic">'.
 	form::field('nb',3,3,$nb_per_page).' '.
 	__('comments per page').'</label></p>'.
Index: admin/media.php
===================================================================
--- admin/media.php	(revision 3034)
+++ admin/media.php	(revision 3094)
@@ -371,11 +371,19 @@
 
 if ($post_id) {
-	echo '<div class="form-note info"><p>'.sprintf(__('Choose a file to attach to entry %s by clicking on %s.'),
+	echo '<div class="form-note info"><p>'.sprintf(__('Choose a file to attach to entry %s by clicking on %s'),
 		'<a href="'.$core->getPostAdminURL($post_type,$post_id).'">'.html::escapeHTML($post_title).'</a>',
-		'<img src="images/plus.png" alt="'.__('Attach this file to entry').'" />').'</p></div>';
+		'<img src="images/plus.png" alt="'.__('Attach this file to entry').'" />');
+	if ($core_media_writable) {
+		echo ' '.__('or').' '.sprintf('<a href="#fileupload">%s</a>',__('upload a new file'));
+	}
+	echo '</p></div>';
 }
 if ($popup) {
-	echo '<div class="info"><p>'.sprintf(__('Choose a file to insert into entry by clicking on %s.'),
-		'<img src="images/plus.png" alt="'.__('Attach this file to entry').'" />').'</p></div>';
+	echo '<div class="info"><p>'.sprintf(__('Choose a file to insert into entry by clicking on %s'),
+		'<img src="images/plus.png" alt="'.__('Attach this file to entry').'" />');
+	if ($core_media_writable) {
+		echo ' '.__('or').' '.sprintf('<a href="#fileupload">%s</a>',__('upload a new file'));
+	}
+	echo '</p></div>';
 }
 
Index: admin/media_item.php
===================================================================
--- admin/media_item.php	(revision 2889)
+++ admin/media_item.php	(revision 3093)
@@ -498,4 +498,22 @@
 	echo '<a href="'.$core->adminurl->get('admin.media.item',array_merge($page_url_params,array("size" => "o","tab"=>"media-details-tab"))).'">'.__('original').'</a>';
 	echo '</p>';
+
+	if ($thumb_size != 'o' && isset($file->media_thumb[$thumb_size])) {
+		$p = path::info($file->file);
+		$alpha = ($p['extension'] == 'png') || ($p['extension'] == 'PNG');
+		$thumb = sprintf(($alpha ? $core->media->thumb_tp_alpha : $core->media->thumb_tp),$p['dirname'],$p['base'],'%s');
+		$thumb_file = sprintf($thumb,$thumb_size);
+		$T = getimagesize($thumb_file);
+		$stats = stat($thumb_file);
+		echo
+		'<h3>'.__('Thumbnail details').'</h3>'.
+		'<ul>'.
+		'<li><strong>'.__('Image width:').'</strong> '.$T[0].' px</li>'.
+		'<li><strong>'.__('Image height:').'</strong> '.$T[1].' px</li>'.
+		'<li><strong>'.__('File size:').'</strong> '.files::size($stats[7]).'</li>'.
+		'<li><strong>'.__('File URL:').'</strong> <a href="'.$file->media_thumb[$thumb_size].'">'.
+			$file->media_thumb[$thumb_size].'</a></li>'.
+		'</ul>';
+	}
 }
 
@@ -514,5 +532,14 @@
 '<ul>'.
 	'<li><strong>'.__('File owner:').'</strong> '.$file->media_user.'</li>'.
-	'<li><strong>'.__('File type:').'</strong> '.$file->type.'</li>'.
+	'<li><strong>'.__('File type:').'</strong> '.$file->type.'</li>';
+if ($file->media_image)
+{
+	$S = getimagesize($file->file);
+	echo
+	'<li><strong>'.__('Image width:').'</strong> '.$S[0].' px</li>'.
+	'<li><strong>'.__('Image height:').'</strong> '.$S[1].' px</li>';
+	unset($S);
+}
+echo
 	'<li><strong>'.__('File size:').'</strong> '.files::size($file->size).'</li>'.
 	'<li><strong>'.__('File URL:').'</strong> <a href="'.$file->file_url.'">'.$file->file_url.'</a></li>'.
Index: inc/admin/class.dc.favorites.php
===================================================================
--- inc/admin/class.dc.favorites.php	(revision 2725)
+++ inc/admin/class.dc.favorites.php	(revision 3075)
@@ -315,5 +315,6 @@
 				true,
 				$v['id'],
-				$v['class']
+				$v['class'],
+				true
 			);
 		}
Index: inc/admin/class.dc.menu.php
===================================================================
--- inc/admin/class.dc.menu.php	(revision 2566)
+++ inc/admin/class.dc.menu.php	(revision 3075)
@@ -22,18 +22,29 @@
 		$this->title = $title;
 		$this->itemSpace = $itemSpace;
+		$this->pinned = array();
 		$this->items = array();
 	}
 
-	public function addItem($title,$url,$img,$active,$show=true,$id=null,$class=null)
+	public function addItem($title,$url,$img,$active,$show=true,$id=null,$class=null,$pinned=false)
 	{
 		if($show) {
-			$this->items[] = $this->itemDef($title,$url,$img,$active,$id,$class);
+			$item = $this->itemDef($title,$url,$img,$active,$id,$class);
+			if ($pinned) {
+				$this->pinned[] = $item;
+			} else {
+				$this->items[$title] = $item;
+			}
 		}
 	}
 
-	public function prependItem($title,$url,$img,$active,$show=true,$id=null,$class=null)
+	public function prependItem($title,$url,$img,$active,$show=true,$id=null,$class=null,$pinned=false)
 	{
 		if ($show) {
-			array_unshift($this->items,$this->itemDef($title,$url,$img,$active,$id,$class));
+			$item = $this->itemDef($title,$url,$img,$active,$id,$class);
+			if ($pinned) {
+				array_unshift($this->pinned,$item);
+			} else {
+				$this->items[$title] = $item;
+			}
 		}
 	}
@@ -41,5 +52,5 @@
 	public function draw()
 	{
-		if (count($this->items) == 0) {
+		if (count($this->items) + count($this->pinned) == 0) {
 			return '';
 		}
@@ -50,12 +61,27 @@
 		'<ul>'."\n";
 
-		for ($i=0; $i<count($this->items); $i++)
+		// 1. Display pinned items (unsorted)
+		for ($i=0; $i<count($this->pinned); $i++)
+		{
+			if ($i+1 < count($this->pinned) && $this->itemSpace != '') {
+				$res .= preg_replace('|</li>$|',$this->itemSpace.'</li>',$this->pinned[$i]);
+				$res .= "\n";
+			} else {
+				$res .= $this->pinned[$i]."\n";
+			}
+		}
+
+		// 2. Display unpinned itmes (sorted)
+		$i = 0;
+		dcUtils::lexicalKeySort($this->items);
+		foreach ($this->items as $title => $item)
 		{
 			if ($i+1 < count($this->items) && $this->itemSpace != '') {
-				$res .= preg_replace('|</li>$|',$this->itemSpace.'</li>',$this->items[$i]);
+				$res .= preg_replace('|</li>$|',$this->itemSpace.'</li>',$item);
 				$res .= "\n";
 			} else {
-				$res .= $this->items[$i]."\n";
+				$res .= $item."\n";
 			}
+			$i++;
 		}
 
Index: inc/admin/lib.admincombos.php
===================================================================
--- inc/admin/lib.admincombos.php	(revision 3011)
+++ inc/admin/lib.admincombos.php	(revision 3082)
@@ -37,5 +37,5 @@
 		while ($categories->fetch()) {
 			$categories_combo[] = new formSelectOption (
-				str_repeat('&nbsp;&nbsp;',$categories->level-1).($categories->level-1 == 0 ? '' : '&bull; ').html::escapeHTML($categories->cat_title).' ('.$categories->nb_post.')',
+                html::escapeHTML($categories->cat_title).' ('.$categories->nb_post.')',
 				($use_url ? $categories->cat_url : $categories->cat_id),
 				($categories->level-1 ? 'sub-option'.($categories->level-1) : '')
@@ -152,5 +152,5 @@
 			$editors_combo[$v] = $v;
 		}
-		
+
 		return $editors_combo;
 	}
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 3080)
+++ inc/admin/lib.dc.page.php	(revision 3086)
@@ -177,24 +177,27 @@
 		}
 
-		// Display breadcrumb (if given) before any error message
+		// Display breadcrumb (if given) before any error messages
 		echo $breadcrumb;
 
-		if ($core->error->flag()) {
-			echo
-			'<div class="error"><p><strong>'.(count($core->error->getErrors()) > 1 ? __('Errors:') : __('Error:')).'</strong></p>'.
+		// Display notices and errors
+		echo self::notices();
+	}
+
+	public static function notices()
+	{
+		global $core;
+		static $error_displayed = false;
+		$res = '';
+
+		// return error messages if any
+		if ($core->error->flag() && !$error_displayed) {
+			$res .= '<div class="error"><p><strong>'.(count($core->error->getErrors()) > 1 ? __('Errors:') : __('Error:')).'</strong></p>'.
 			$core->error->toHTML().
 			'</div>';
-		}
-
-		// Display notices
-		echo self::notices();
-	}
-
-	public static function notices()
-	{
+			$error_displayed = true;
+		}
+
 		// return notices if any
-		$res = '';
 		if (isset($_SESSION['notifications'])) {
-			$notifications = $_SESSION['notifications'];
 			foreach ($_SESSION['notifications'] as $notification) {
 				$res .= self::getNotification($notification);
@@ -366,10 +369,6 @@
 		echo $breadcrumb;
 
-		if ($core->error->flag()) {
-			echo
-			'<div class="error" role="alert"><strong>'.__('Errors:').'</strong>'.
-			$core->error->toHTML().
-			'</div>';
-		}
+		// Display notices and errors
+		echo self::notices();
 	}
 
@@ -545,10 +544,10 @@
 	}
 
-	public static function cssLoad($src, $media='screen')
+	public static function cssLoad($src,$media='screen',$v='')
 	{
 		$escaped_src = html::escapeHTML($src);
 		if (!isset(self::$loaded_css[$escaped_src])) {
 			self::$loaded_css[$escaped_src] = true;
-			$escaped_src = self::appendVersion($escaped_src);
+			$escaped_src = self::appendVersion($escaped_src,$v);
 
 			return '<link rel="stylesheet" href="'.$escaped_src.'" type="text/css" media="'.$media.'" />'."\n";
@@ -556,28 +555,22 @@
 	}
 
-	public static function jsLoad($src)
+	public static function jsLoad($src,$v='')
 	{
 		$escaped_src = html::escapeHTML($src);
 		if (!isset(self::$loaded_js[$escaped_src])) {
 			self::$loaded_js[$escaped_src] = true;
-			$escaped_src = self::appendVersion($escaped_src);
+			$escaped_src = self::appendVersion($escaped_src,$v);
 			return '<script type="text/javascript" src="'.$escaped_src.'"></script>'."\n";
 		}
 	}
 
-	private static function appendVersion($src)
-	{
-		if (strpos($src,'?')===false) {
-			$src .= '?v=';
-		} else {
-			$src .= '&v=';
-		}
-
+	private static function appendVersion($src,$v='')
+	{
+		$src .= (strpos($src,'?') === false ? '?' : '&').'v=';
 		if (defined('DC_DEV') && DC_DEV === true) {
 			$src .= md5(uniqid());
 		} else {
-			$src .= DC_VERSION;
-		}
-
+			$src .= ($v === '' ? DC_VERSION : $v);
+		}
 		return $src;
 	}
Index: inc/admin/lib.pager.php
===================================================================
--- inc/admin/lib.pager.php	(revision 3087)
+++ inc/admin/lib.pager.php	(revision 3089)
@@ -180,14 +180,19 @@
 			}
 
-			$html_block .= '<tr>'.
-			'<th colspan="2" class="first">'.__('Title').'</th>'.
-			'<th scope="col">'.__('Date').'</th>'.
-			'<th scope="col">'.__('Category').'</th>'.
-			'<th scope="col">'.__('Author').'</th>'.
-			'<th scope="col"><img src="images/comments.png" alt="" title="'.__('Comments').'" /><span class="hidden">'.__('Comments').'</span></th>'.
-			'<th scope="col"><img src="images/trackbacks.png" alt="" title="'.__('Trackbacks').'" /><span class="hidden">'.__('Trackbacks').'</span></th>'.
-			'<th scope="col">'.__('Status').'</th>'.
-			'</tr>%s</table></div>';
-
+			$cols = array(
+				'title' =>			'<th colspan="2" class="first">'.__('Title').'</th>',
+				'date' =>			'<th scope="col">'.__('Date').'</th>',
+				'category' =>		'<th scope="col">'.__('Category').'</th>',
+				'author' =>			'<th scope="col">'.__('Author').'</th>',
+				'comments' =>		'<th scope="col"><img src="images/comments.png" alt="" title="'.__('Comments').
+									'" /><span class="hidden">'.__('Comments').'</span></th>',
+				'trackbacks' =>		'<th scope="col"><img src="images/trackbacks.png" alt="" title="'.__('Trackbacks').
+									'" /><span class="hidden">'.__('Trackbacks').'</span></th>',
+				'status' =>			'<th scope="col">'.__('Status').'</th>'
+			);
+			$cols = new ArrayObject($cols);
+			$this->core->callBehavior('adminPostListHeader',$this->core,$this->rs,$cols);
+
+			$html_block .= '<tr>'.implode(iterator_to_array($cols)).'</tr>%s</table></div>';
 			if ($enclose_block) {
 				$html_block = sprintf($enclose_block,$html_block);
@@ -262,16 +267,23 @@
 		' id="p'.$this->rs->post_id.'">';
 
-		$res .=
-		'<td class="nowrap">'.
-		form::checkbox(array('entries[]'),$this->rs->post_id,$checked,'','',!$this->rs->isEditable()).'</td>'.
-		'<td class="maximal" scope="row"><a href="'.$this->core->getPostAdminURL($this->rs->post_type,$this->rs->post_id).'">'.
-		html::escapeHTML($this->rs->post_title).'</a></td>'.
-		'<td class="nowrap count">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->post_dt).'</td>'.
-		'<td class="nowrap">'.$cat_title.'</td>'.
-		'<td class="nowrap">'.html::escapeHTML($this->rs->user_id).'</td>'.
-		'<td class="nowrap count">'.$this->rs->nb_comment.'</td>'.
-		'<td class="nowrap count">'.$this->rs->nb_trackback.'</td>'.
-		'<td class="nowrap status">'.$img_status.' '.$selected.' '.$protected.' '.$attach.'</td>'.
-		'</tr>';
+		$cols = array(
+			'check' =>			'<td class="nowrap">'.
+								form::checkbox(array('entries[]'),$this->rs->post_id,$checked,'','',!$this->rs->isEditable()).
+								'</td>',
+			'title' =>			'<td class="maximal" scope="row"><a href="'.
+								$this->core->getPostAdminURL($this->rs->post_type,$this->rs->post_id).'">'.
+								html::escapeHTML($this->rs->post_title).'</a></td>',
+			'date' =>			'<td class="nowrap count">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->post_dt).'</td>',
+			'category' =>		'<td class="nowrap">'.$cat_title.'</td>',
+			'author' =>			'<td class="nowrap">'.html::escapeHTML($this->rs->user_id).'</td>',
+			'comments' =>		'<td class="nowrap count">'.$this->rs->nb_comment.'</td>',
+			'trackbacks' =>		'<td class="nowrap count">'.$this->rs->nb_trackback.'</td>',
+			'status' =>			'<td class="nowrap status">'.$img_status.' '.$selected.' '.$protected.' '.$attach.'</td>'
+		);
+		$cols = new ArrayObject($cols);
+		$this->core->callBehavior('adminPostListValue',$this->core,$this->rs,$cols);
+
+		$res .= implode(iterator_to_array($cols));
+		$res .= '</tr>';
 
 		return $res;
@@ -293,11 +305,17 @@
 			$html_block =
 			'<div class="table-outer clear">'.
-			'<table><caption class="hidden">'.__('Entries list').'</caption><tr>'.
-			'<th scope="col">'.__('Title').'</th>'.
-			'<th scope="col">'.__('Date').'</th>'.
-			'<th scope="col">'.__('Author').'</th>'.
-			'<th scope="col">'.__('Status').'</th>'.
-			'</tr>%s</table></div>';
-
+			'<table><caption class="hidden">'.__('Entries list').'</caption><tr>';
+
+			$cols = array(
+				'title' =>		'<th scope="col">'.__('Title').'</th>',
+				'date' =>		'<th scope="col">'.__('Date').'</th>',
+				'author' =>		'<th scope="col">'.__('Author').'</th>',
+				'status' =>		'<th scope="col">'.__('Status').'</th>'
+			);
+
+			$cols = new ArrayObject($cols);
+			$this->core->callBehavior('adminPostMiniListHeader',$this->core,$this->rs,$cols);
+
+			$html_block .= '<tr>'.implode(iterator_to_array($cols)).'</tr>%s</table></div>';
 			if ($enclose_block) {
 				$html_block = sprintf($enclose_block,$html_block);
@@ -359,12 +377,19 @@
 		' id="p'.$this->rs->post_id.'">';
 
-		$res .=
-		'<td scope="row" class="maximal"><a href="'.$this->core->getPostAdminURL($this->rs->post_type,$this->rs->post_id).'" '.
-		'title="'.html::escapeHTML($this->rs->getURL()).'">'.
-		html::escapeHTML($this->rs->post_title).'</a></td>'.
-		'<td class="nowrap count">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->post_dt).'</td>'.
-		'<td class="nowrap">'.html::escapeHTML($this->rs->user_id).'</td>'.
-		'<td class="nowrap status">'.$img_status.' '.$selected.' '.$protected.' '.$attach.'</td>'.
-		'</tr>';
+		$cols = array(
+			'title' =>		'<td scope="row" class="maximal"><a href="'.
+							$this->core->getPostAdminURL($this->rs->post_type,$this->rs->post_id).'" '.
+							'title="'.html::escapeHTML($this->rs->getURL()).'">'.
+							html::escapeHTML($this->rs->post_title).'</a></td>',
+			'date' =>		'<td class="nowrap count">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->post_dt).'</td>',
+			'author' =>		'<td class="nowrap">'.html::escapeHTML($this->rs->user_id).'</td>',
+			'status' =>		'<td class="nowrap status">'.$img_status.' '.$selected.' '.$protected.' '.$attach.'</td>'
+		);
+
+		$cols = new ArrayObject($cols);
+		$this->core->callBehavior('adminPostMiniListValue',$this->core,$this->rs,$cols);
+
+		$res .= implode(iterator_to_array($cols));
+		$res .= '</tr>';
 
 		return $res;
@@ -422,17 +447,20 @@
 			}
 
-			$html_block .= '<tr>'.
-			'<th colspan="2" scope="col" abbr="comm" class="first">'.__('Type').'</th>'.
-			'<th scope="col">'.__('Author').'</th>'.
-			'<th scope="col">'.__('Date').'</th>'.
-			'<th scope="col" class="txt-center">'.__('Status').'</th>';
+			$cols = array(
+				'type' =>	'<th colspan="2" scope="col" abbr="comm" class="first">'.__('Type').'</th>',
+				'author' =>	'<th scope="col">'.__('Author').'</th>',
+				'date' =>	'<th scope="col">'.__('Date').'</th>',
+				'status' =>	'<th scope="col" class="txt-center">'.__('Status').'</th>'
+			);
 			if ($spam) {
-				$html_block .=
-				'<th scope="col">'.__('IP').'</th>'.
-				'<th scope="col">'.__('Spam filter').'</th>';
-			}
-			$html_block .=
-			'<th scope="col" abbr="entry">'.__('Entry').'</th>'.
-			'</tr>%s</table></div>';
+				$cols['ip'] = '<th scope="col">'.__('IP').'</th>';
+				$cols['spam_filter'] = '<th scope="col">'.__('Spam filter').'</th>';
+			}
+			$cols['entry'] = '<th scope="col" abbr="entry">'.__('Entry').'</th>';
+
+			$cols = new ArrayObject($cols);
+			$this->core->callBehavior('adminCommentListHeader',$this->core,$this->rs,$cols);
+
+			$html_block .= '<tr>'.implode(iterator_to_array($cols)).'</tr>%s</table></div>';
 
 			if ($enclose_block) {
@@ -505,14 +533,17 @@
 		' id="c'.$this->rs->comment_id.'">';
 
-		$res .=
-		'<td class="nowrap">'.
-		form::checkbox(array('comments[]'),$this->rs->comment_id,$checked,'','',0).'</td>'.
-		'<td class="nowrap" abbr="'.__('Type and author').'" scope="row">'.
-			'<a href="'.$comment_url.'" title="'.$comment_title.'">'.
-			'<img src="images/edit-mini.png" alt="'.__('Edit').'"/> '.
-			($this->rs->comment_trackback ? __('trackback') : __('comment')).' '.'</a></td>'.
-		'<td class="nowrap maximal"><a href="'.$author_url.'">'.html::escapeHTML($this->rs->comment_author).'</a></td>'.
-		'<td class="nowrap count">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->comment_dt).'</td>'.
-		'<td class="nowrap status txt-center">'.$img_status.'</td>';
+		$cols = array(
+			'check' =>	'<td class="nowrap">'.
+						form::checkbox(array('comments[]'),$this->rs->comment_id,$checked,'','',0).'</td>',
+			'type' =>	'<td class="nowrap" abbr="'.__('Type and author').'" scope="row">'.
+						'<a href="'.$comment_url.'" title="'.$comment_title.'">'.
+						'<img src="images/edit-mini.png" alt="'.__('Edit').'"/> '.
+						($this->rs->comment_trackback ? __('trackback') : __('comment')).' '.'</a></td>',
+			'author' =>	'<td class="nowrap maximal"><a href="'.$author_url.'">'.
+						html::escapeHTML($this->rs->comment_author).'</a></td>',
+			'date'	=>	'<td class="nowrap count">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->comment_dt).'</td>',
+			'status' =>	'<td class="nowrap status txt-center">'.$img_status.'</td>'
+		);
+
 		if ($spam) {
 			$filter_name = '';
@@ -524,13 +555,16 @@
 				}
 			}
-			$res .=
-			'<td class="nowrap"><a href="'.$core->adminurl->get("admin.comments",array('ip' => $this->rs->comment_ip)).'">'.$this->rs->comment_ip.'</a></td>'.
-			'<td class="nowrap">'.$filter_name.'</td>';
-		}
-		$res .=
-		'<td class="nowrap discrete"><a href="'.$post_url.'">'.
-		$post_title.'</a>'.
-		($this->rs->post_type != 'post' ? ' ('.html::escapeHTML($this->rs->post_type).')' : '').'</td>';
-
+			$cols['ip'] = '<td class="nowrap"><a href="'.
+				$core->adminurl->get("admin.comments",array('ip' => $this->rs->comment_ip)).'">'.
+				$this->rs->comment_ip.'</a></td>';
+			$cols['spam_filter'] = '<td class="nowrap">'.$filter_name.'</td>';
+		}
+		$cols['entry'] = '<td class="nowrap discrete"><a href="'.$post_url.'">'.$post_title.'</a>'.
+			($this->rs->post_type != 'post' ? ' ('.html::escapeHTML($this->rs->post_type).')' : '').'</td>';
+
+		$cols = new ArrayObject($cols);
+		$this->core->callBehavior('adminCommentListValue',$this->core,$this->rs,$cols);
+
+		$res .= implode(iterator_to_array($cols));
 		$res .= '</tr>';
 
@@ -565,12 +599,16 @@
 			}
 
-			$html_block .= '<tr>'.
-			'<th colspan="2" scope="col" class="first">'.__('Username').'</th>'.
-			'<th scope="col">'.__('First Name').'</th>'.
-			'<th scope="col">'.__('Last Name').'</th>'.
-			'<th scope="col">'.__('Display name').'</th>'.
-			'<th scope="col" class="nowrap">'.__('Entries (all types)').'</th>'.
-			'</tr>%s</table></div>';
-
+			$cols = array(
+				'username' =>		'<th colspan="2" scope="col" class="first">'.__('Username').'</th>',
+				'first_name' =>		'<th scope="col">'.__('First Name').'</th>',
+				'last_name' =>		'<th scope="col">'.__('Last Name').'</th>',
+				'display_name' =>	'<th scope="col">'.__('Display name').'</th>',
+				'entries' =>		'<th scope="col" class="nowrap">'.__('Entries (all types)').'</th>'
+			);
+
+			$cols = new ArrayObject($cols);
+			$this->core->callBehavior('adminUserListHeader',$this->core,$this->rs,$cols);
+
+			$html_block .= '<tr>'.implode(iterator_to_array($cols)).'</tr>%s</table></div>';
 			if ($enclose_block) {
 				$html_block = sprintf($enclose_block,$html_block);
@@ -607,16 +645,28 @@
 			$img_status = sprintf($img,__('superadmin'),'superadmin.png');
 		}
-		return
-		'<tr class="line">'.
-		'<td class="nowrap">'.form::hidden(array('nb_post[]'),(integer) $this->rs->nb_post).
-		form::checkbox(array('users[]'),$this->rs->user_id).'</td>'.
-		'<td class="maximal" scope="row"><a href="'.$this->core->adminurl->get('admin.user',array('id' => $this->rs->user_id)).'">'.
-		$this->rs->user_id.'</a>&nbsp;'.$img_status.'</td>'.
-		'<td class="nowrap">'.html::escapeHTML($this->rs->user_firstname).'</td>'.
-		'<td class="nowrap">'.html::escapeHTML($this->rs->user_name).'</td>'.
-		'<td class="nowrap">'.html::escapeHTML($this->rs->user_displayname).'</td>'.
-		'<td class="nowrap count"><a href="'.$this->core->adminurl->get('admin.posts',array('user_id' => $this->rs->user_id)).'">'.
-		$this->rs->nb_post.'</a></td>'.
-		'</tr>';
+
+		$res = '<tr class="line">';
+
+		$cols = array(
+			'check' =>			'<td class="nowrap">'.form::hidden(array('nb_post[]'),(integer) $this->rs->nb_post).
+								form::checkbox(array('users[]'),$this->rs->user_id).'</td>',
+			'username' =>		'<td class="maximal" scope="row"><a href="'.
+								$this->core->adminurl->get('admin.user',array('id' => $this->rs->user_id)).'">'.
+								$this->rs->user_id.'</a>&nbsp;'.$img_status.'</td>',
+			'first_name' =>		'<td class="nowrap">'.html::escapeHTML($this->rs->user_firstname).'</td>',
+			'last_name' =>		'<td class="nowrap">'.html::escapeHTML($this->rs->user_name).'</td>',
+			'display_name' =>	'<td class="nowrap">'.html::escapeHTML($this->rs->user_displayname).'</td>',
+			'entries' =>		'<td class="nowrap count"><a href="'.
+								$this->core->adminurl->get('admin.posts',array('user_id' => $this->rs->user_id)).'">'.
+								$this->rs->nb_post.'</a></td>'
+		);
+
+		$cols = new ArrayObject($cols);
+		$this->core->callBehavior('adminUserListValue',$this->core,$this->rs,$cols);
+
+		$res .= implode(iterator_to_array($cols));
+		$res .= '</tr>';
+
+		return $res;
 	}
 }
Index: inc/admin/prepend.php
===================================================================
--- inc/admin/prepend.php	(revision 3059)
+++ inc/admin/prepend.php	(revision 3075)
@@ -69,5 +69,6 @@
 
 	$url = $core->adminurl->get($adminurl);
-	$_menu[$section]->prependItem($desc,$url,$icon,preg_match('/'.preg_quote($url).'(\?.*)?$/',$_SERVER['REQUEST_URI']),$perm);
+	$_menu[$section]->prependItem($desc,$url,$icon,
+		preg_match('/'.preg_quote($url).'(\?.*)?$/',$_SERVER['REQUEST_URI']),$perm,null,null,true);
 }
 
Index: inc/core/class.dc.error.php
===================================================================
--- inc/core/class.dc.error.php	(revision 2566)
+++ inc/core/class.dc.error.php	(revision 3074)
@@ -30,13 +30,4 @@
 	/** @var string HTML error item pattern */
 	protected $html_item = "<li>%s</li>\n";
-
-	/**
-	* Object constructor.
-	*/
-	public function __construct()
-	{
-		$this->code = 0;
-		$this->msg = '';
-	}
 
 	/**
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 3097)
+++ inc/prepend.php	(revision 3098)
@@ -140,5 +140,5 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.8.2');
+define('DC_VERSION','2.9-dev');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
Index: locales/fi/resources.php
===================================================================
--- locales/fi/resources.php	(revision 3091)
+++ locales/fi/resources.php	(revision 3091)
@@ -0,0 +1,26 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2013 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -ke- suomennettu 
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+
+$__resources['rss_news'] = 'http://dotclear.org/blog/feed/category/News/atom';
+
+$__resources['doc'] = array(
+	"Dotclear-dokumentaatio" => 'http://dotclear.org/documentation/2.0',
+	'Dotclearin esittely' => 'http://dotclear.org/documentation/2.0/overview/tour',
+	"Käyttäjän opas" => 'http://dotclear.org/documentation/2.0/usage',
+	"Asennus- ja hallintaoppaat" => 'http://dotclear.org/documentation/2.0/admin',
+	"Dotclearin tukipalstat" => 'http://forum.dotclear.net/'
+);
+
+?>
Index: plugins/aboutConfig/index.php
===================================================================
--- plugins/aboutConfig/index.php	(revision 2824)
+++ plugins/aboutConfig/index.php	(revision 3091)
@@ -133,5 +133,5 @@
 '<thead>'.
 '<tr>'."\n".
-'  <th class="nowrap">Setting ID</th>'."\n".
+'  <th class="nowrap">'.__('Setting ID').'</th>'."\n".
 '  <th>'.__('Value').'</th>'."\n".
 '  <th>'.__('Type').'</th>'."\n".
Index: plugins/dcCKEditor/_define.php
===================================================================
--- plugins/dcCKEditor/_define.php	(revision 3056)
+++ plugins/dcCKEditor/_define.php	(revision 3090)
@@ -16,5 +16,5 @@
 	/* Description*/		"dotclear CKEditor integration",
 	/* Author */			"dotclear Team",
-	/* Version */			"1.0.3",
+	/* Version */			"1.1.0",
 	array(
 		'permissions' =>	'usage,contentadmin',
Index: plugins/dcCKEditor/_install.php
===================================================================
--- plugins/dcCKEditor/_install.php	(revision 3052)
+++ plugins/dcCKEditor/_install.php	(revision 3090)
@@ -25,4 +25,5 @@
 $settings->dcckeditor->put('list_buttons', true, 'boolean', 'Add list buttons?', false, true);
 $settings->dcckeditor->put('textcolor_button', false, 'boolean', 'Add text color button?', false, true);
+$settings->dcckeditor->put('background_textcolor_button', false, 'boolean', 'Add background text color button?', false, true);
 $settings->dcckeditor->put('cancollapse_button', false, 'boolean', 'Add collapse button?', false, true);
 $settings->dcckeditor->put('format_select', true, 'boolean', 'Add format selection?', false, true);
Index: plugins/dcCKEditor/_post_config.php
===================================================================
--- plugins/dcCKEditor/_post_config.php	(revision 3056)
+++ plugins/dcCKEditor/_post_config.php	(revision 3090)
@@ -96,4 +96,8 @@
 	CKEDITOR.plugins.addExternal('media',dotclear.dcckeditor_plugin_url+'/js/ckeditor-plugins/media/');
 	CKEDITOR.plugins.addExternal('img',dotclear.dcckeditor_plugin_url+'/js/ckeditor-plugins/img/');
+	<?php if (!empty($dcckeditor_textcolor_button) || !empty($dcckeditor_background_textcolor_button)):?>
+	// button add "More Colors..." can be added if colordialog plugin is enabled
+	CKEDITOR.config.colorButton_enableMore = true;
+	<?php endif;?>
 
 <?php if (!empty($extraPlugins) && count($extraPlugins)>0) {
@@ -120,5 +124,5 @@
 		// format tags
 <?php if (!empty($dcckeditor_format_tags)):?>
-        format_tags: '<?php echo $dcckeditor_format_tags;?>',
+		format_tags: '<?php echo $dcckeditor_format_tags;?>',
 <?php else:?>
 		format_tags: 'p;h1;h2;h3;h4;h5;h6;pre;address',
@@ -178,14 +182,17 @@
 					'Source'
 <?php if (!empty($dcckeditor_textcolor_button)):?>
-                ,'TextColor'
+					,'TextColor'
+<?php endif;?>
+<?php if (!empty($dcckeditor_background_textcolor_button)):?>
+					,'BGColor'
 <?php endif;?>
 				]
 			},
-            {
-                name: 'special',
-                items: [
-                    'Maximize'
-                ]
-            },
+			{
+				name: 'special',
+				items: [
+					'Maximize'
+				]
+			},
 			<?php // add extra buttons comming from dotclear plugins
 			if (!empty($extraPlugins) && count($extraPlugins)>0) {
